## By Feature

- declarative data and event binding

- functional state management

  - highly predictable and testable
  - integrated into the component model so that the same solution used for managing the state of a single component can also be used as a central "state container" for a larger tree of components
  - components can broadcast actions publicly or privately, making light work of component intercoms

- Simple yet powerful CLI

  - build components and pages with plain .html, .css, and .js files

- separation of concerns

- declarative / logic-less templates

  - no javascript knowledge required to work on the template
  - can be expressed in pure HTML / no compiler necessary

- sensible constraints

  ## By Goal

> one of the nice qualities of the Mosaic framework design is that everything can be expressed using standard HTML, CSS, and JS without requiring any compilation or transpilation. of course, you can still use a transpiler if you specifically _want_ to use js that isn't part of the language yet, but it isn't required in any way.

- The CLI allows you to get even closer to the metal by writing your components in plain .html, .css, and .js

      components/
          app/
              index.html
              index.css
              index.js
          header/
              index.html
              index.css
              index.js
          footer/
              index.html
              index.css
              index.js

  the CLI simply generates an entry module that defines a Mosaic component from the raw html, css, and js files.

- With the CLI, components can be _active_ (control their own state) or _passive_ (have no state of their own). Think of Passive components like HTML includes, because sometimes you just want to reuse chunks of HTML and/or CSS without having to wire tens to hundreds of components together with props. When the CLI sees a component that has no .js file, it assumes this to be a _passive_ component and simply rolls it into the component that included it. the child and parent share the same scope meaning that all data values available in the parent are also available in the child without any prop wiring required.

        components/
            app/
                index.html
                index.css
                index.js
            header/
                index.html
                index.css
            footer/
                index.html
                index.css
